unit FDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, XDKSteps, ComCtrls, StdCtrls, XDKGen, XDKSnips;

type
  TDemoForm = class(TForm)
    Steps: TxdkSteps;
    xdkStepTab1: TxdkStepTab;
    xdkStepTab2: TxdkStepTab;
    xdkStepTab3: TxdkStepTab;
    Panel1: TPanel;
    Memo1: TMemo;
    Label2: TLabel;
    RadioGroup1: TRadioGroup;
    StaticText1: TStaticText;
    MainModuleCreator: TxdkModuleCreator;
    ProjectCreator: TxdkProjectCreator;
    MainModuleSnippet: TxdkSnippet;
    Label3: TLabel;
    procedure xdkStepTab3Next(Sender: TObject);
    procedure StepsFinish(Sender: TObject);
    procedure StepsCancel(Sender: TObject);
    function MainModuleCreatorSourceWriting(UnitIdent, FormIdent,
      AncestorIdent: String): String;
    function ProjectCreatorSourceWriting(
      const ProjectName: String): String;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure CreateUnit;
    procedure CreateForm;
    procedure CreateDataModule;
    procedure CreateFormWithButton;
    procedure CreateProject;
  end;

var
  DemoForm: TDemoForm;

implementation

uses
  UDemo;

{$R *.DFM}

procedure TDemoForm.xdkStepTab3Next(Sender: TObject);
begin
  Close;
end;

procedure TDemoForm.StepsFinish(Sender: TObject);
begin
  case RadioGroup1.ItemIndex of
    0: CreateUnit;
    1: CreateForm;
    2: CreateDataModule;
    3: CreateFormWithButton;
    4: CreateProject;
  end;
  // closing form with OK modal command
  ModalResult:=mrOk;
end;

procedure TDemoForm.StepsCancel(Sender: TObject);
begin
  // closing form with CANCEL modal command
  ModalResult:=mrCancel;
end;

procedure TDemoForm.CreateUnit;
begin
  DemoDataModule.UnitCreator.ModuleCreate;
end;

procedure TDemoForm.CreateForm;
begin
  DemoDataModule.FormCreator.ModuleCreate;
end;

procedure TDemoForm.CreateDataModule;
begin
  DemoDataModule.DMCreator.ModuleCreate;
end;

procedure TDemoForm.CreateFormWithButton;
begin
  DemoDataModule.BtnFormCreator.ModuleCreate;
end;

procedure TDemoForm.CreateProject;
begin
  ProjectCreator.ProjectCreate;
end;

function TDemoForm.MainModuleCreatorSourceWriting(UnitIdent, FormIdent,
  AncestorIdent: String): String;
begin
   MainModuleSnippet.ParamValues['UnitName']:=UnitIdent; // the first way to set params value
// note: DoResultCode is not case-sensitive
   MainModuleSnippet.Params.Add('formname='+FormIdent); // the second way to set params value
   MainModuleSnippet.DoResultCode;  // replacing all params to neccessary values
   Result:=MainModuleSnippet.ResultCodeText; //return result code as long string
end;

function TDemoForm.ProjectCreatorSourceWriting(
  const ProjectName: String): String;
const
  ProjectSource =
    'uses'+CRLF+
    '  Forms;'+CRLF2+
    'begin'+CRLF+
    '  Application.Initialize;'+CRLF+
    '  Application.Run;'+CRLF+
    'end.'+CRLF;

begin
  Result:='program '+ProjectName+';'+CRLF+
          ProjectSource;
end;


end.
